#include "sets.h"
#include <iostream.h>

unsigned long BinTreeNode::counter = 0;


BinTreeNode::BinTreeNode (int d)
{
  left = right = 0;
  data = d;
  counter++;
}

BinTreeNode::~BinTreeNode ()
{
  --counter;
}

Set::~Set()
{
  clear();
}

#ifdef TREE

Set::Set ()
{
  root = 0;
  size = 0;
}

bool insert (PBinTreeNode &t, int x)
{
  if (t == 0)
    {
      t = new BinTreeNode(x);
      return true;
    }
  else if (t->data == x)
    {
      return false;
    }
  else if (x < t->data)
    return insert (t->left, x);
  else
    return insert (t->right, x);
}




//*************************************************************************
//******** LAS SIGUIENTES TRES FUNCIONES SON LAS QUE IMPLEMNT. **********
//*************************************************************************


void Set::copyall(PBinTreeNode &v,const PBinTreeNode &w)
{                                   //** Esta funcin permite copiar
  if ( w!= 0)                       //   los valores de un arbol a otro
    {                               //   arbol recorriendo el arbol a
       v=new BinTreeNode(w->data);  //   copiar en pre-orden.
       copyall(v->left,w->left);    //**
       copyall(v->right,w->right);
    }
}


Set& Set::operator=(const Set & s)//** Se implementa la sobrecarga
{                                 //   del operador =. Esto permite
  clear();                        //   que se realice una copia en
  size= s.size;                   //   profundidad del Set implementado
  copyall( root,s.root);          //   con TREE.
  return *this;                   //**
}


Set::Set (const Set& s) //** Se implementa el constructor de copia
{                       //   para asegurar el buen funcionamiento
  root=0;               //   del operador =.
  size=s.size;          //**
  copyall( root, s.root);
  }


//*************************************************************************
//******************** TERMINO DE MODIFICACIONES **************************
//*************************************************************************



Set& Set::add (int x)
{
  if (insert (root, x))
     size++;
  return *this;
}


bool Set::member (int x) const
{
  BinTreeNode *t = root;
  while (t != 0)
    {
      if (t->data == x)
	return true;
      else if (x < t->data)
        t = t->left;

	else
	 t = t->right;

    }
  return false;
}


void deleteAll (PBinTreeNode& t)
{
  if (t != 0)
    {
      deleteAll(t->left);
      deleteAll(t->right);
      delete t;
      t = 0;
    }
}


Set& Set::clear()
{
  size = 0;
  deleteAll(root);
  return *this;
}


#else



Set::Set ()
{
  size = 0;
}


Set& Set::add (int x)
{
  if (!member(x))
    {
      members[size] = x;
      size++;
    }
  return *this;
}


bool Set::member (int x) const
{
  for (int i = 0; i < size; i++)
    if (x == members[i])
      return true;
  return false;
}


Set& Set::clear()
{
  size = 0;
  return *this;
}


#endif

