#include "sets2.h"
#include <iostream.h>

unsigned long BinTreeNode::counter = 0;

Set::Set ()
{
  size = 0;
}

Set::~Set()
{
}

void Set::copyall(PBinTreeNode &v,const PBinTreeNode &w) //** Funcin Virtual Pura **//
{
}

Set& Set::add (int)
{
  cerr << "*** can't add to general sets " << endl;
  return *this;
}

bool Set::member (int) const
{
  cerr << "*** can't check membership in general sets " << endl;
  return false;
}

Set& Set::clear()
{
  cerr << "*** can't clear general sets " << endl;
  return *this;
}

void Set::copyMembers (Set& into) const
{
  cerr << "*** can't copy general sets " << endl;
}

Set* Set::dupheap() const //**Funcin Virtual Pura**//
{
  cerr << "*** can't create copy in heap " << endl;
  return NULL;
}

const Set& Set::operator= (const Set& s)
{
  return *this;
}

/////////////////////////

BinTreeNode::BinTreeNode (int d)
{
  left = right = 0;
  data = d;
  counter++;
}

BinTreeNode::~BinTreeNode ()
{
  --counter;
}

//////////////////////

TreeSet::TreeSet (): Set()
{
  root = 0;
}

bool insert (PBinTreeNode &t, int x)
{
  if (t == 0)
    {
      t = new BinTreeNode(x);
      return true;
    }
  else if (t->data == x)
    {
      return false;
    }
  else if (x < t->data)
    return insert (t->left, x);
  else
    return insert (t->right, x);
}


//*************************************************************************
//************************* FUNCIONES AADIDAS TREESET ********************
//*************************************************************************


void TreeSet::copyMembers(const TreeSet& s) //** Se implementa la copia
{                                           //   de un TreeSet.
 clear();                                   //**
 size=s.size;
 copyall(root,s.root);
}

void TreeSet::copyall(PBinTreeNode &v, const PBinTreeNode &w)
{                                     //** Esta funcin permite copiar
  if ( w!= 0)                         //   los valores de un TreeSet a
    {                                 //   otro, recorriendo el arbol
       v=new BinTreeNode(w->data);    //   a copiar en pre-orden.
       copyall(v->left,w->left);      //**
       copyall(v->right,w->right);
    }
}


TreeSet& TreeSet::operator=(const TreeSet & s)//** Se implementa la sobrecarga
{                                             //   del operador (=). Esto permite
  copyMembers(s);                             //   que se realice una copia en
  return *this;                               //   en profundidad el TreeSet
}                                             //**


TreeSet::TreeSet (const TreeSet& s) : Set() //** Se implementa el constructor
{                                           //   de copia del TreeSet que
  root=0;                                   //   asegura el buen funcionamiento
  copyMembers(s);                           //   del operador (=).
 }                                          //**


Set* TreeSet::dupheap() const //** Se crea funcin que permite
{                             //   crear una copia de un TreeSet
  TreeSet *s;                 //   en el heap.  Esto implica
  s=new TreeSet(*this);       //   asignacin dinmica y permite
  return (s);                 //   que se trabaje efectivamente
}                             //   con un TreeSet que con un Set.
			      //**	

TreeSet::~TreeSet () //** Se implementa el destructor del objeto TreeSet
{                    //   ya que sin el no se destruyen los nodos
 clear();            //   correspondientes.
}                    //**

//*************************************************************************
//********************** FIN FUNCIONES AADIDAS TREESET *******************
//*************************************************************************


Set& TreeSet::add (int x)
{
  if (insert (root, x))
     size++;
  return *this;
}

bool TreeSet::member (int x) const
{
  BinTreeNode *t = root;
  while (t != 0)
    {
      if (t->data == x)
	return true;
      else if (x < t->data)
        t = t->left;
      else
	t = t->right;
    }
  return false;
}

void deleteAll (PBinTreeNode& t)
{
  if (t != 0)
    {
      deleteAll(t->left);
      deleteAll(t->right);
      delete t;
      t = 0;
    }
}

Set& TreeSet::clear()
{
  size = 0;
  deleteAll(root);
  return *this;
}



ArraySet::ArraySet () : Set()
{
}

Set& ArraySet::add (int x)
{
  if (!member(x))
    {
      members[size] = x;
      size++;
    }
  return *this;
}

bool ArraySet::member (int x) const
{
  for (int i = 0; i < size; i++)
    if (x == members[i])
      return true;
  return false;
}

Set& ArraySet::clear()
{
  size = 0;
  return *this;
}

void ArraySet::copyMembers(ArraySet& into) const
{
  for (int i=0; i<size; i++)
   into.add(members[i]);
}

//*************************************************************************
//************************* FUNCIONES AADIDAS ARRAYSET *******************
//*************************************************************************

ArraySet::~ArraySet() //** Se implementa el destructor del
{                     //   objeto ArraySet ya que no estaba
clear();              //   implementado.
}                     //**


Set* ArraySet::dupheap() const //** Se crea funcin que permite crear
{                              //   una copia de un ArraySet en el heap.
  ArraySet *s;                 //   Esto implica asignacin dinmica y
  s=new ArraySet();            //   permite que se trabaje efectivamente
  copyMembers(*s);             //   con un ArraySet que con un Set.
  return (s);                  //**
}

//*************************************************************************
//********************** FIN FUNCIONES AADIDAS ARRAYSET ******************
//*************************************************************************

//////////////////////////






