#ifndef SETS_H
#define SETS_H

struct BinTreeNode;
typedef BinTreeNode *PBinTreeNode;

class Set 
{
public:
  Set ();
  virtual ~Set ();

  virtual Set& add(int);
  virtual bool member (int) const;
  virtual Set& clear();
  int extent () const;

  virtual const Set& operator= (const Set& );
  				//** Declaracin de la
                                //   sobrecarga del operador(=)
                                //   para un Set
                                //   (Funcin Virtual Pura).
                                //**
  virtual void copyall(PBinTreeNode &v,const PBinTreeNode &w);
         //** Declaracin de la funcin de copia
         //   (Funcin Virtual Pura).
         //**
  virtual Set* dupheap()const;
  			//** Declaracin de la funcin dupheap
                        //   para Set (Funcin Virtual Pura).
                        //**




protected:

  int size;
  virtual void copyMembers (Set& into) const;
};

class ArraySet : public Set
{
public:
  ArraySet ();
  ~ArraySet ();//** Declaracin del destructor del ArraySet. **

  Set& add(int);
  bool member (int) const;
  Set& clear();

  Set* dupheap() const;//** Declaracin de la funcin dupheap
                       //   para ArraySet.
                       //**

private:
  int members[100];
  virtual void copyMembers (ArraySet& into) const;
};

class TreeSet:  public Set
{
public:
  TreeSet ();
  ~TreeSet ();//** Declaracin del destructor para el TreeSet **

  Set& add(int);
  bool member (int) const;
  Set& clear();

  TreeSet (const TreeSet& s);//** Declaracin del constructor
  			     //   de copia para Tree.
  			     //**
  TreeSet& operator= (const TreeSet&);//** Declaracin de la
                                      //   sobrecarga del operador(=)
                                      //   para Tree.
                                      //**
  void copyall(PBinTreeNode &v, const PBinTreeNode &w);
               //** Declaracin de la funcin de copia de un TreeSet **

  Set* dupheap() const;//** Declaracin de la funcin dupheap
                       //   para ArraySet.
                       //**


private:
  PBinTreeNode root;
  virtual void copyMembers (const TreeSet& );
};

/* In C++ a struct is similar to a class
but is used for storing related data
together. Structs are implemented almost
exactly like clases, but the word
struct replaces the word class. The only
difference between a struct and a
class in C++ is that by default data and
fucntions in a struct are public,
whereas the default in a class is that
everything is private. */

struct BinTreeNode
{
  int data;
  BinTreeNode *left, *right;

  static unsigned long counter;

  BinTreeNode (int d);
  ~BinTreeNode ();
};

inline int Set::extent() const
{
  return size;
}

#endif
